# $Revision: 1.117 $, $Date: 2012/03/20 19:15:03 $
#
# Conditional build
%bcond_without	tests		# make check
%bcond_without	java		# build java subpackage

%if "%{pld_release}" == "ac"
%ifnarch i586 i686 pentium3 pentium4 athlon %{x8664}
%undefine	with_java
%endif
%endif

%define		tzcode_ver	2012a
%define		tzdata_ver	2012a
Summary:	Timezone data
Summary(pl.UTF-8):	Dane o strefach czasowych
Name:		tzdata
Version:	%{tzdata_ver}
Release:	2
License:	Public Domain (database), BSD/LGPL v2.1+ (code/test suite)
Group:		Base
# The tzdata-base-0.tar.bz2 is a simple building infrastructure and
# a test suite. It is occasionally updated from glibc sources, and as
# such is under LGPL v2+, but none of this ever gets to be part of
# final zoneinfo files.
Source0:	%{name}-base-0.tar.bz2
# Source0-md5:	e36d2f742c22f8c8dbf0686ac9769b55
# ftp://elsie.nci.nih.gov/pub/ has been shut down because of lawsuit
#Source1Download: http://www.iana.org/time-zones/
Source1:	http://www.iana.org/time-zones/repository/releases/%{name}%{tzdata_ver}.tar.gz
# Source1-md5:	cc43867f4768e5c2e8315d9b3cac62ed
#Source2Download: http://www.iana.org/time-zones/
Source2:	http://www.iana.org/time-zones/repository/releases/tzcode%{tzcode_ver}.tar.gz
# Source2-md5:	a72bb8c29893ee3bfd1101aca29d4064
Source3:	timezone.init
Source4:	timezone.sysconfig
Source5:	javazic.tar.gz
# Source5-md5:	6a3392cd5f1594d13c12c1a836ac8d91
Source6:	timezone.upstart
Source7:	timezone.service
Source8:	timezone.sh
Patch1:		javazic-fixup.patch
Patch2:		install.patch
URL:		http://www.twinsun.com/tz/tz-link.htm
BuildRequires:	rpm >= 4.4.9-56
BuildRequires:	rpmbuild(macros) >= 1.300
%if %{with java}
BuildRequires:	jdk
BuildRequires:	jpackage-utils
BuildRequires:	rpm-javaprov
%endif
Requires:	/sbin/chkconfig
Requires:	rc-scripts >= 0.4.3.0
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
This package contains data files with rules for various timezones
around the world.

%description -l pl.UTF-8
Ten pakiet zawiera pliki z danymi na temat reguł stref czasowych na
całym świecie.

%package -n java-tzdata
Summary:	Timezone data for Java
Summary(pl.UTF-8):	Dane stref czasowych dla Javy
Group:		Base

%description -n java-tzdata
This package contains timezone information for use by Java runtimes.

%description -n java-tzdata -l pl.UTF-8
Ten pakiet zawiera informacje o strefach czasowych przeznaczone dla
programów w Javie.

%package zoneinfo_right
Summary:	Non-POSIX (real) time zones
Summary(es.UTF-8):	Zonas de tiempo reales (no de POSIX)
Summary(pl.UTF-8):	Nie-POSIX-owe (prawdziwe) strefy czasowe
Group:		Libraries
Obsoletes:	glibc-zoneinfo_right

%description zoneinfo_right
You don't want this. Details at:
<http://sources.redhat.com/ml/libc-alpha/2000-12/msg00068.html>.

%description zoneinfo_right -l es.UTF-8
No lo necesita. Encontrará los detalles en:
<http://sources.redhat.com/ml/libc-alpha/2000-12/msg00068.html>.

%description zoneinfo_right -l pl.UTF-8
Nie potrzebujesz tego. Szczegóły pod:
<http://sources.redhat.com/ml/libc-alpha/2000-12/msg00068.html>.

%package devel
Summary:	tzfile header file
Summary(pl.UTF-8):	Plik nagłówkowy tzfile
Group:		Development/Libraries

%description devel
Header file for timezone database.

%description devel -l pl.UTF-8
Plik nagłówkowy bazy danych stref czasowych.

%prep
%setup -qc
mv tzdata/* .
%{__tar} xzf %{SOURCE1} -C tzdata
install -d tzcode
%{__tar} xzf %{SOURCE2} -C tzcode
%patch2 -p1

%{__sed} -e "
s|@objpfx@|`pwd`/obj/|
s|@datadir@|%{_datadir}|
s|@install_root@|$RPM_BUILD_ROOT|
" 'Makeconfig.in' > Makeconfig

grep -v tz-art.htm tzcode/tz-link.htm > tzcode/tz-link.html

%if %{with java}
install -d javazic
tar zxf %{SOURCE5} -C javazic
cd javazic
%patch1

# Hack alert! sun.tools may be defined and installed in the
# VM. In order to guarantee that we are using IcedTea/OpenJDK
# for creating the zoneinfo files, rebase all the packages
# from "sun." to "rht.". Unfortunately, gcj does not support
# any of the -Xclasspath options, so we must go this route
# to ensure the greatest compatibility.
# XXX: do we want 'pld' instead of 'rht'?
mv sun rht
find . -type f -name '*.java' -print0 \
	| xargs -0 -- sed -i -e 's:sun\.tools\.:rht.tools.:g' \
						 -e 's:sun\.util\.:rht.util.:g'
cd -
%endif

%build
%{__make}

%if %{with java}
cd javazic
%javac -source 1.5 -target 1.5 -classpath . $(find -name '*.java')
cd ../tzdata
%java -classpath ../javazic/ rht.tools.javazic.Main -V %{version} \
	-d ../zoneinfo/java \
	africa antarctica asia australasia europe northamerica pacificnew \
	southamerica backward etcetera solar87 solar88 solar89 systemv \
	../javazic/tzdata_jdk/gmt ../javazic/tzdata_jdk/jdk11_backward
cd ..
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{/etc/{sysconfig,rc.d/init.d},%{_mandir}/man5,%{_includedir},%{systemdunitdir}}
%{__make} install

%if %{with tests}
# test needs to be ran after "make install", as it uses installed files
: ====================TESTING=========================
%{__make} check \
	CC="%{__cc}" \
	CFLAGS="%{rpmcflags} %{rpmldflags}"
: ====================TESTING END=====================
%endif

# glibc.spec didn't keep it. so won't here either.
rm -rf $RPM_BUILD_ROOT%{_datadir}/zoneinfo/posix
# behave more like glibc.spec
ln -sf %{_sysconfdir}/localtime	$RPM_BUILD_ROOT%{_datadir}/zoneinfo/localtime
ln -sf localtime $RPM_BUILD_ROOT%{_datadir}/zoneinfo/posixtime
ln -sf localtime $RPM_BUILD_ROOT%{_datadir}/zoneinfo/posixrules

> $RPM_BUILD_ROOT/etc/localtime

# header file
cp -p tzcode/tzfile.h $RPM_BUILD_ROOT%{_includedir}/tzfile.h
cp -p tzcode/tzfile.5 $RPM_BUILD_ROOT%{_mandir}/man5

install -p %{SOURCE3} $RPM_BUILD_ROOT/etc/rc.d/init.d/timezone
cp -p %{SOURCE4} $RPM_BUILD_ROOT/etc/sysconfig/timezone

install -d $RPM_BUILD_ROOT/etc/init
cp -p %{SOURCE6} $RPM_BUILD_ROOT/etc/init/timezone.conf

install -p %{SOURCE7} $RPM_BUILD_ROOT%{systemdunitdir}/timezone.service
install -p %{SOURCE8} $RPM_BUILD_ROOT/lib/systemd/pld-timezone

%if %{with java}
cp -a zoneinfo/java $RPM_BUILD_ROOT%{_datadir}/javazi
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add timezone
%service timezone restart
%systemd_post timezone.service

%preun
if [ "$1" = "0" ]; then
	/sbin/chkconfig --del timezone

	# save for postun
	cp -af /etc/localtime /etc/localtime.rpmsave
fi
%systemd_preun timezone.service

%postun
if [ "$1" = "0" ]; then
	if [ ! -f /etc/localtime -a -f /etc/localtime.rpmsave ]; then
		echo >&2 "Preserving /etc/localtime"
		mv -f /etc/localtime{.rpmsave,}
	fi
fi
%systemd_reload

%triggerpostun -- rc-scripts < 0.4.1.4
/sbin/chkconfig --add timezone

%triggerpostun -- tzdata < 2008b-4
if ! grep -q '^TIMEZONE=' /etc/sysconfig/timezone; then
	. /etc/sysconfig/timezone

	if [ -z $ZONE_INFO_AREA ]; then
		TIMEZONE=$TIME_ZONE
	else
		TIMEZONE=$ZONE_INFO_AREA/$TIME_ZONE
	fi

	echo "TIMEZONE=\"$TIMEZONE\"" >> /etc/sysconfig/timezone

	%service timezone restart
fi

%triggerpostun -- tzdata < 2012a-2
%systemd_trigger timezone.service

%files
%defattr(644,root,root,755)
%doc tzcode/README tzcode/Theory tzcode/tz-link.html
%ghost /etc/localtime
%config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/timezone
%attr(754,root,root) /etc/rc.d/init.d/timezone
%config(noreplace) %verify(not md5 mtime size) /etc/init/timezone.conf
%{systemdunitdir}/timezone.service
%attr(755,root,root) /lib/systemd/pld-timezone

%{_datadir}/zoneinfo
%exclude %{_datadir}/zoneinfo/right

%if %{with java}
%files -n java-tzdata
%defattr(644,root,root,755)
%{_datadir}/javazi
%endif

%files zoneinfo_right
%defattr(644,root,root,755)
%{_datadir}/zoneinfo/right

%files devel
%defattr(644,root,root,755)
%doc tzcode/tzfile.5.txt
%{_includedir}/tzfile.h
%{_mandir}/man5/tzfile.5*

%define date    %(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: tzdata.spec,v $
Revision 1.117  2012/03/20 19:15:03  glen
- print note that /etc/localtime is preserved if you uninstall the package

Revision 1.116  2012/03/16 11:14:12  baggins
- rel 2

Revision 1.115  2012/03/16 10:55:25  baggins
- rel 2
- systemd support

Revision 1.114  2012/03/01 18:00:31  glen
- up to 2012a

Revision 1.113  2011/11/26 18:46:08  glen
- R: chkconfig due rpm bugs

Revision 1.112  2011/11/06 07:47:13  qboosh
- updated to 2011n

Revision 1.111  2011/10/25 17:08:21  qboosh
- updated to 2011m (covers Ukraine time changes issue)

Revision 1.110  2011/10/20 17:08:25  qboosh
- source download URL

Revision 1.109  2011/10/20 17:03:23  qboosh
- new source URLs
- updated tzdata to 2011l

Revision 1.108  2011/09/25 10:40:55  glen
- update upstart deps

Revision 1.107  2011/08/30 12:05:49  glen
- up to 2011i

Revision 1.106  2011/07/30 13:46:36  glen
- upstart: add upstart_controlled

Revision 1.105  2011/07/03 12:18:00  adamg
- updated to 2011h (tzdata)

Revision 1.104  2011/04/27 06:45:18  glen
- BR jdk

Revision 1.103  2011/04/27 06:42:40  glen
- disable java on ac where java-sun not present

Revision 1.102  2011/04/26 12:38:13  marti
- tzdata and tzcode up to 2011g

Revision 1.101  2011/04/12 16:04:43  marti
- tzdata up to 2011f

Revision 1.100  2011/04/04 11:37:09  glen
- up to 2011e
- rename java package to java-tzdata and enabled

Revision 1.99  2011/03/22 11:17:40  glen
- up to 2011d

Revision 1.98  2011/03/08 11:07:04  glen
- up to 2011c, package upstart config

Revision 1.97  2011/02/08 09:17:26  glen
- up to 2011b

Revision 1.96  2011/01/25 14:07:10  glen
- up to 2011a

Revision 1.95  2010/11/02 10:13:16  glen
- tzdata 2010o

Revision 1.94  2010/10/25 16:45:43  glen
- revert breakage in r1.90 (wrong TZDIR), make check works fine by itself

Revision 1.93  2010/10/25 16:32:47  glen
- will send without tests

Revision 1.92  2010/10/25 16:24:51  glen
- update tzdata-base-0.tar.bz2 from tzdata-2010l-1.fc15.src.rpm

Revision 1.91  2010/10/25 16:18:21  glen
- 2010n, but testing fails

Revision 1.90  2010/10/21 22:13:30  arekm
- run timezone tests manually

Revision 1.89  2010/10/17 18:29:28  arekm
- up to 2010m

Revision 1.88  2010/09/15 05:58:32  qboosh
- pl for -java

Revision 1.87  2010/09/14 21:36:01  glen
- java BR

Revision 1.86  2010/09/14 21:33:20  glen
- java subpackage adopted from fc (disabled as needs testing and stuff)

Revision 1.85  2010/05/23 18:28:39  arekm
- up to 2010j

Revision 1.84  2010/05/13 18:31:21  sparky
- dropped (no longer used) BR: gawk, perl-base

Revision 1.83  2010/04/07 07:09:54  glen
- cosmetics

Revision 1.82  2010/04/07 06:25:35  amateja
- updated to 2010h

Revision 1.81  2010/03/24 07:41:04  amateja
- updated to 2010f

Revision 1.80  2010/03/09 07:27:13  amateja
- updated to 2010e

Revision 1.79  2010/03/02 08:47:58  amateja
- updated to 2010c

Revision 1.78  2010/01/28 09:20:47  amateja
- updated to 2010b

Revision 1.77  2010/01/18 18:43:16  glen
- tzdata 2010a

Revision 1.76  2010/01/03 22:12:07  adamg
- updated to 2009t/2009u

Revision 1.75  2009/11/10 00:19:18  adamg
- updated to 2009r

Revision 1.74  2009/11/07 15:47:49  adamg
- updated 2009q

Revision 1.73  2009/10/26 14:39:06  amateja
- updated to 2009p

Revision 1.72  2009/10/09 06:27:11  amateja
- updated to 2009n

Revision 1.71  2009/08/18 17:41:10  adamg
- updated to 2009l (tzdata only)

Revision 1.70  2009/08/01 19:15:18  adamg
- updated to 2009k (both tzcode and tzdata)

Revision 1.69  2009/06/20 22:15:12  adamg
- updated to 2009i/2009j

Revision 1.68  2009/05/26 23:41:45  adamg
- updated to 2009h (both tzcode and tzdata)

Revision 1.67  2009/05/04 10:12:12  amateja
- updated to 2009g (tzdata only)

Revision 1.66  2009/04/11 18:05:01  adamg
- updated to 2009e (both tzdata and tzcode)

Revision 1.65  2009/02/09 23:46:12  adamg
- updated to 2009b (both tzcode and tzdata)

Revision 1.64  2009/02/09 18:01:25  qboosh
- more complete summary

Revision 1.63  2009/02/08 15:01:56  adamg
- spaces->tabs where needed
- pl summary, pl/en description for devel
- install tzfile.h man page / doc
- missing defattr

Revision 1.62  2009/02/08 06:46:21  aredridel
- package tzfile.h

Revision 1.61  2009/01/23 18:29:25  adamg
- updated to 2009a (both tzcode and tzdata)

Revision 1.60  2008/10/30 09:16:24  adamg
- updated to 2008i

Revision 1.59  2008/10/14 07:14:38  adamg
- updated to 2008h (both tzcode and tzdata)

Revision 1.58  2008/10/11 09:34:34  adamg
- updated to 2008g (both tzcode and tzdata)

Revision 1.57  2008/09/15 20:39:39  adamg
- updated to 2008f

Revision 1.56  2008/08/27 14:38:57  arekm
- revert, chkconfig dep should be enough

Revision 1.55  2008/08/27 13:42:58  arekm
- rel 3; /etc/rc.d/ dir structure is needed

Revision 1.54  2008/07/31 06:55:25  glen
- release 2

Revision 1.53  2008/07/30 18:10:51  qboosh
- tzcode updated to 2008e

Revision 1.52  2008/07/28 20:30:52  adamg
- updated to 2008e

Revision 1.51  2008/07/03 11:33:58  glen
- cosmetic (sorted)

Revision 1.50  2008/05/31 19:38:20  adamg
- updated to 2008c

Revision 1.49  2008-04-29 09:20:14  glen
- release 5

Revision 1.48  2008-04-24 18:39:24  glen
- spelling

Revision 1.47  2008-04-24 17:34:41  megabajt
- added trigger to make older confing compatible with the new one
- release 4

Revision 1.46  2008-04-24 13:54:13  megabajt
- improved previous commit log
- non-integer release (3.1) as trigger is needed

Revision 1.45  2008-04-24 13:31:29  megabajt
- merged ZONE_INFO_AREA and TIME_ZONE into TIMEZONE
- release 3

Revision 1.44  2008-03-24 22:47:08  glen
- use own builddir
- only tzdata was updated in previous commit

Revision 1.43  2008-03-24 22:36:52  glen
- release 2

Revision 1.42  2008-03-24 22:29:58  adamg
- updated to 2008b [tzdata only]

Revision 1.41  2008-03-22 02:17:50  adamg
- updated to 2008a

Revision 1.40  2008-03-04 20:00:28  glen
- different approach to preserve /etc/localtime after uninstall

Revision 1.39  2008-03-04 19:40:26  arekm
- rel 7; revert /etc/localtime removal (rpm has deps on symlinks)

Revision 1.38  2008-03-04 16:36:55  arekm
- rel 6; there is no cp -c in newer coreutils (and is not needed)

Revision 1.37  2008-02-25 23:07:33  glen
- don't own /etc/localtime, allowing sysadmin to install pkg once to get proper tzfile

Revision 1.36  2008-02-04 15:14:52  glen
- rel 4

Revision 1.35  2008-02-04 15:14:29  glen
- plain R: chkconfig; rel 3

Revision 1.34  2008-01-13 22:45:54  glen
- rel 2 (1 for ac)

Revision 1.33  2008-01-13 17:36:59  qboosh
- updated to 2007k
- updated init script to support try-restart|force-reload actions (as reconfiguration)

Revision 1.32  2007-12-26 13:58:40  glen
- rel 2

Revision 1.31  2007-12-09 20:44:21  radek
- version(s) 2007j

Revision 1.30  2007-11-02 22:03:37  qboosh
- added test-update patch, disables failure on Asia/Tokyo zone
  (with last daylight saving in 1951)

Revision 1.29  2007/11/02 16:18:46  qboosh
- bcond header
- removed excessive _s
- added URL
- proper License (database itself is Public Domain, the rest exists in sources only)

Revision 1.28  2007/11/01 20:38:11  arekm
- added tests bcond

Revision 1.27  2007/11/01 20:36:25  arekm
- tzdata 2007i/tzcode 2007h; test fails on Asia/Tokyo timezone

Revision 1.26  2007/11/01 02:45:55  sls
- ver. 2007h

Revision 1.25  2007/09/05 13:50:35  baggins
- rel 2

Revision 1.24  2007/08/24 12:38:41  glen
- 2007g

Revision 1.23  2007/05/16 14:28:54  glen
- 2007f

Revision 1.22  2007/04/01 01:05:15  arekm
- up to 2007d

Revision 1.21  2007/03/08 14:02:45  glen
- trigger when migrating from rc-scripts; rel 2

Revision 1.20  2007/02/28 16:13:41  glen
- 2007c

Revision 1.19  2007/02/25 01:07:24  glen
- timezone initscript moved here; rel 2

Revision 1.18  2007/02/13 22:58:53  glen
- 2007b

Revision 1.17  2007/02/12 22:09:18  glen
- tabs in preamble

Revision 1.16  2007/02/12 01:06:35  baggins
- converted to UTF-8

Revision 1.15  2007/02/06 19:54:42  arekm
- rel 2; package /etc/localtime

Revision 1.14  2007/01/29 00:25:26  glen
- 2007a

Revision 1.13  2006/11/30 20:36:56  qboosh
- updated to 2006p

Revision 1.12  2006/11/25 19:27:36  qboosh
- updated to 2006o

Revision 1.11  2006/10/31 23:13:44  glen
- 2006n

Revision 1.10  2006/07/30 14:46:11  sparky
- pass __cc, rpmcflags and rpmldflags to make check

Revision 1.9  2006/05/24 07:45:54  qboosh
- unified

Revision 1.8  2006/05/17 12:56:58  glen
- be more like glibc.spec

Revision 1.7  2006/05/16 21:49:58  glen
- separate zoneinfo_right like in glibc

Revision 1.6  2006/05/16 21:32:07  glen
- upstream 2006g

Revision 1.5  2006/04/09 12:23:09  glen
- updated to 2006c

Revision 1.4  2006/04/09 12:15:28  glen
- adapter is smart

Revision 1.3  2006/04/08 20:52:31  darekr
- remove BR glibc-devel which is required by rpm-build

Revision 1.2  2005/04/25 20:48:08  qboosh
- pl

Revision 1.1  2005/04/24 14:52:56  patrys
- Initial PLD release
